=== debian/watch ===
version=4
opts="dversionmangle=s/\+dfsg\d*$//, repacksuffix=+dfsg" \
https://github.com/libwbxml/libwbxml/tags /libwbxml/libwbxml/archive/refs/tags/libwbxml-([\d\.]+).tar.gz
